{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLBAPTrayIcon {$IFNDEF KOL_MCK}, mirror, Classes,  mckBAPTrayIcon, mckObjs,  Controls, mckCtrls {$ENDIF};
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mirror;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Button1: TKOLButton;
    Button2: TKOLButton;
    Button3: TKOLButton;
    EditBox1: TKOLEditBox;
    Button4: TKOLButton;
    Button5: TKOLButton;
    EditBox2: TKOLEditBox;
    EditBox3: TKOLEditBox;
    GroupBox1: TKOLGroupBox;
    RadioBox1: TKOLRadioBox;
    RadioBox2: TKOLRadioBox;
    RadioBox3: TKOLRadioBox;
    RadioBox4: TKOLRadioBox;
    Label1: TKOLLabel;
    PopupMenu1: TKOLPopupMenu;
    CheckBox1: TKOLCheckBox;
    cbHideMin: TKOLCheckBox;
    BAPTrayIcon1: TKOLBAPTrayIcon;
    cbHideClose: TKOLCheckBox;
    procedure Button1Click(Sender: PObj);
    procedure Button2Click(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure Button4Click(Sender: PObj);
    procedure Button5Click(Sender: PObj);
    procedure PopupMenu1mExitMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure PopupMenu1mShowMenu(Sender: PMenu; Item: Integer);
    procedure PopupMenu1mHideMenu(Sender: PMenu; Item: Integer);
    procedure KOLForm1Hide(Sender: PObj);
    procedure KOLForm1Show(Sender: PObj);
    function KOLForm1Message(var Msg: tagMSG; var Rslt: Integer): Boolean;
    procedure BAPTrayIcon1MouseDown(Sender: PControl;
      var Mouse: TMouseEventData);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

{$R icons.res}

procedure TForm1.Button1Click(Sender: PObj);
begin
  BAPTrayIcon1.Icon := LoadIcon(hInstance, 'ic');
  BAPTrayIcon1.AddIcon;
end;

procedure TForm1.Button2Click(Sender: PObj);
begin
  BAPTrayIcon1.DeleteIcon;
end;

procedure TForm1.Button3Click(Sender: PObj);
begin
  BAPTrayIcon1.ToolTip := EditBox1.Text;
end;

procedure TForm1.Button4Click(Sender: PObj);
var x: Integer;
begin
  BAPTrayIcon1.BalloonText := EditBox3.Text;
  BAPTrayIcon1.BalloonTitle := EditBox2.Text;
  x := 0;
  if RadioBox1.Checked then x := _NIIF_NONE;    { 0 }
  if RadioBox2.Checked then x := _NIIF_INFO;    { 1 }
  if RadioBox3.Checked then x := _NIIF_WARNING; { 2 }
  if RadioBox4.Checked then x := _NIIF_ERROR;   { 3 }
  BAPTrayIcon1.ShowBalloon(x);
end;

procedure TForm1.Button5Click(Sender: PObj);
begin
  BAPTrayIcon1.HideBalloon;
end;

procedure TForm1.PopupMenu1mExitMenu(Sender: PMenu; Item: Integer);
begin
  Applet.Close;
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  Applet.Visible := FALSE;
  BAPTrayIcon1.ToolTip := Form.Text;
  BAPTrayIcon1.Icon := LoadIcon(hInstance, 'ic');
  BAPTrayIcon1.AddIcon;
end;

procedure TForm1.PopupMenu1mShowMenu(Sender: PMenu; Item: Integer);
begin
  Applet.Visible := TRUE;
  SetForegroundWindow(Applet.Handle);
end;

procedure TForm1.PopupMenu1mHideMenu(Sender: PMenu; Item: Integer);
begin
  Form.Hide;
end;

procedure TForm1.KOLForm1Hide(Sender: PObj);
begin
  if CheckBox1.Checked then BAPTrayIcon1.AddIcon;
  if Form.Visible and not CheckBox1.Checked then BAPTrayIcon1.AddIcon;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  if CheckBox1.Checked then BAPTrayIcon1.DeleteIcon;
end;

procedure TForm1.BAPTrayIcon1MouseDown(Sender: PControl; var Mouse: TMouseEventData);
begin
  if Mouse.Button = mbLeft then Sender.Show;
  if Mouse.Button = mbRight then
  begin
    SetForegroundWindow(Sender.Handle);
    PopupMenu1.Popup(Mouse.X, Mouse.Y);
  end;
end;

function TForm1.KOLForm1Message(var Msg: tagMSG;  var Rslt: Integer): Boolean;
begin
  Result := FALSE;

  if Msg.message = WM_SYSCOMMAND then
  begin
    case Msg.wParam of
      SC_MINIMIZE: {    }
        if cbHideMin.Checked then
        begin
          Form.Hide;
          Result := TRUE;
        end;

      SC_CLOSE: {    }
        if cbHideClose.Checked then
        begin
          Form.Hide;
          Result := TRUE;
        end;
      end;{ case Msg.wParam }
  end;
end;

end.